<?php

namespace App\Livewire\Studio\Manage;

use App\Livewire\Forms\Studio\Manage\FaqForm;
use App\Models\Faq as FaqModel;
use App\Traits\WithAuthorization;
use App\Traits\WithCloseModal;
use App\Traits\WithConfirmation;
use App\Traits\WithToast;
use App\Traits\WithUpdatedData;
use Flux\Flux;
use Livewire\Attributes\On;
use Livewire\Attributes\Title;
use Livewire\Component;

#[Title('FAQs')]
class Faq extends Component
{
    use WithAuthorization, WithCloseModal, WithConfirmation, WithToast, WithUpdatedData;

    public FaqForm $form;

    public string $method = 'create';

    public string $modalTitle = '';

    #[On('modal:open')]
    public function openModal(string $method, string $modalTitle, ?string $id = null)
    {
        $this->resetValidation();
        $this->resetErrorBag();

        $this->method = $method;
        $this->modalTitle = $modalTitle;

        if ($id) {
            $this->form->setFaq(FaqModel::byHashOrFail($id));
        }
    }

    public function create()
    {
        $this->canOrAbort('create faq');

        $this->form->store();

        $this->dispatch('refreshDatatable');

        $this->toast('FAQs berhasil ditambahkan.');

        Flux::modals()->close();
    }

    public function update()
    {
        $this->canOrAbort('update faq');

        $this->form->update();

        $this->dispatch('refreshDatatable');

        $this->toast('FAQs berhasil diperbarui.');

        Flux::modals()->close();
    }

    public function delete(FaqModel $faq)
    {
        $this->form->faq = $faq;

        $this->form->delete();

        $this->dispatch('refreshDatatable');

        $this->toast('FAQs berhasil dihapus.');

        Flux::modals()->close();
    }

    #[On('fn:sortOrder')]
    public function sortOrder(FaqModel $faq, string $direction)
    {
        $this->canOrAbort('update faq');

        $this->form->faq = $faq;

        $this->form->sortOrder($direction);

        $this->dispatch('refreshDatatable');
    }

    public function render()
    {
        return view('livewire.studio.manage.faqs', [
            'pageTitle' => 'FAQs',
        ]);
    }
}
